Attribute VB_Name = "Argv"
Option Explicit

Public Function ArgParse(strSwitch As String, Optional ByRef strSetting As String) As Boolean
Dim iPos As Integer
Dim iNextSwitch As Integer

   'Strip off command line switch separator if passed to function
   If Left(strSwitch, 1) = "/" Then strSwitch = Mid(strSwitch, 2)
   If Left(strSwitch, 1) = "-" Then strSwitch = Mid(strSwitch, 2)

   'Check if the option exists in the argument portion of the command line
   'allowing for a prefix of "/" or "-" as a command line separator
   If InStr(LCase(Command()), "-" & LCase(strSwitch)) > 0 Then
      iPos = InStr(LCase(Command()), "-" & LCase(strSwitch))
      ArgParse = True
   ElseIf InStr(LCase(Command()), "/" & LCase(strSwitch)) Then
      iPos = InStr(LCase(Command()), "/" & LCase(strSwitch))
      ArgParse = True
   End If
   
   'If the argument exists check if there is a string setting behind it
   If ArgParse = True Then
      'If the next character after the switch is ":" retrieve the text behind it
      If Mid(Command(), iPos + Len(strSwitch) + 1, 1) = ":" Then
         'If the next character is a double quotes ignore switch
         'separators until the next double quotes
         If Mid(Command(), iPos + Len(strSwitch) + 2, 1) = """" Then
            iNextSwitch = InStr(iPos + Len(strSwitch) + 3, Command(), """")
            If iNextSwitch = 0 Then
               'Couldn't find the ending quote so return to the end of the string
               strSetting = Mid(Command(), iPos + Len(strSwitch) + 2)
            Else
               strSetting = Mid(Command(), iPos + Len(strSwitch) + 3, iNextSwitch - (iPos + Len(strSwitch) + 3))
            End If
            'Note that the surrounding double quotes are stripped
         Else
            'Find the next switch separator or the end of the
            'string and return the text in-between.
            iNextSwitch = InStr(iPos, Command(), "/")
            If iNextSwitch = 0 Then iNextSwitch = InStr(iPos + 1, Command(), "-")
            If iNextSwitch = 0 Then
               'Couldn't find another "-" or "/" so return to the end of the string
               strSetting = Mid(Command(), iPos + Len(strSwitch) + 2)
            Else
               'Return to the next switch
               strSetting = Mid(Command(), iPos + Len(strSwitch) + 2, (iNextSwitch - 1) - (iPos + Len(strSwitch) + 2))
            End If
         End If
         'Trim leading and trailing white space - just to be tidy.
         strSetting = Trim(strSetting)
      End If
   End If
End Function
